// Affirmations - A javascript module for Synchronet by Underminer to display a motivational message
// can be used as part of logon, or wherever you would like to input positivity

load("sbbsdefs.js");
load('http.js');

//
// Variables you can change:
//**************************
//set this to true if you want to show a header/border. Name files affirmation.ans/asc and place in text dir
var showheader = false;
//set this to change default behaviour without arguments to either remote or local file
var localaffirmation = true;
//set this to your local affirmation file location if different
var localaffirmationfile = (system.mods_dir + "affirmations.dat");
// change this if you want to use a different remote endpoint
var affirmationurl = "https://www.affirmations.dev";
// change this array for available qoute colours:
var quotecolours = ["|01", "|02", "|03", "|05", "|07", "|09", "|10", "|11", "|12", "|13", "|15"]
// Change this if your sysop account is not user #1:
var sysopusernumber = 1;




//Things you should not change:
//*****************************
//Do not change the remainder unless you know what you are doing!!!
var localaffirmationarray = [];

function getremoteaffirmation(){
	if (localaffirmation == true){
		console.putmsg("Local file!");
	}
	var affirmation = new HTTPRequest();
	var affirmationresponse = affirmation.Get(affirmationurl);
	if (affirmation.response_code != 200){
		console.writemsg("Error getting data");
		console.pause();
		exit(1);
	}
	else{
		affirmationresponse = JSON.parse(affirmationresponse);
		return affirmationresponse.affirmation;
	}
}
function loadlocalaffirmation(){
	var affirmationfile = new File(localaffirmationfile);

	if (!affirmationfile.open('r')) {
		return;
	}
	var i;
	var raffirmation;
	while (true){
		raffirmation = affirmationfile.readln();
		if (raffirmation === null) {
			break;
		}		
		localaffirmationarray.push(raffirmation);
	}
	affirmationfile.close();
}

function getlocalaffirmation(){
	var affirmationresponse = localaffirmationarray[random(localaffirmationarray.length)];
	return affirmationresponse;
}

function writeaffirmation(affirmationresponse){
	console.clear();
	if (showheader == true){
		(bbs.menu(system.text_dir + "affirmation"));		
	}
	if (affirmationresponse.length <= 78){
		var xposition = (40 - (affirmationresponse.length / 2));	
	}
	else{
		xposition = 1;
	}
	var colourselection = quotecolours[random(quotecolours.length)]
	console.gotoxy(4,10);
	console.putmsg("|14" + system.username(sysopusernumber) + " says:");
	console.gotoxy(4,12);
	console.putmsg(colourselection + "You know something, " + user.alias + "?");
	console.gotoxy(xposition,14);
	console.putmsg( colourselection + affirmationresponse);	
}

function main(){
	if (localaffirmation == true){
		loadlocalaffirmation();
	}
	console.gotoxy(2,4);
	var readyforday = 0;
	while(readyforday == 0){
		if (localaffirmation == true){
			if (localaffirmationarray.length > 0){
				var affirmationresponse = getlocalaffirmation();	
				writeaffirmation(affirmationresponse);							
			}
			else{
				console.putmsg("No data in local array, defaulting to remote");
				console.pause();
				var affirmationresponse = getremoteaffirmation();		
				writeaffirmation(affirmationresponse);
			}
		}
		else{
			var affirmationresponse = getremoteaffirmation();	
			writeaffirmation(affirmationresponse);
		}		
		
		console.gotoxy(2,22);
		if (confirm("Are you ready to face the day")){
		 	readyforday = 1;
		}		
	}

}
if (argc > 1) {
	console.putmsg("Too many arguments!");
	console.pause();
	exit(0);
}
if (argc > 0 && argv[0] == 'REMOTE'){
	localaffirmation = false;
	main();
	exit(0);
}
else if (argc > 0 && argv[0] == 'LOCAL'){
	localaffirmation = true;
	main();
	exit(0);
}
else {
	main();
	exit(0);
}
